<?php

/**
 * PrestaShop module created by VEKIA, a guy from official PrestaShop community ;-)
 *
 * @author    VEKIA https://www.prestashop.com/forums/user/132608-vekia/
 * @copyright 2010-2019 VEKIA
 * @license   This program is not free software and you can't resell and redistribute it
 *
 * CONTACT WITH DEVELOPER http://mypresta.eu
 * support@mypresta.eu
 */
class relatedfree extends Module
{
    public function __construct()
    {
        $this->name = 'relatedfree';
        $this->tab = 'advertising_marketing';
        $this->author = 'MyPresta.eu';
        $this->version = '1.6.5';
        $this->mypresta_link = 'https://mypresta.eu/modules/front-office-features/related-products-free.html';
        $this->bootstrap = true;
        $this->module_key = 'de6f0cf17c8cb0d314ec544203a9f5f5';
        parent::__construct();
        $this->displayName = $this->l('Related products free');
        $this->description = $this->l('Module allows to display custom related products block with products from selected category');
        $this->addproduct = $this->l('Add');
        $this->noproductsfound = $this->l('No products found');
        $this->checkforupdates(0,0);
    }

    public function inconsistency($ret = false) {
        return;
    }

    public function psversion($part = 1)
    {
        $version = _PS_VERSION_;
        $exp = $explode = explode(".", $version);
        if ($part == 1)
        {
            return $exp[1];
        }
        if ($part == 2)
        {
            return $exp[2];
        }
        if ($part == 3)
        {
            return $exp[3];
        }
    }

    public function hookactionAdminControllerSetMedia($params)
    {
        //for update feature purposes
    }

    public function return_rf_tpath()
    {
        $rf_tpath = Configuration::get('rf_tpath');
        if ($rf_tpath != '' && $rf_tpath != false) {
            return $rf_tpath;
        } else {
            return 'product-list.tpl';
        }
    }

    public function checkforupdates($display_msg = 0, $form = 0)
    {
        // ---------- //
        // ---------- //
        // VERSION 14 //
        // ---------- //
        // ---------- //
        $this->mkey = "nlc";
        if (@file_exists('../modules/' . $this->name . '/key.php')) {
            @require_once('../modules/' . $this->name . '/key.php');
        } else {
            if (@file_exists(dirname(__FILE__) . $this->name . '/key.php')) {
                @require_once(dirname(__FILE__) . $this->name . '/key.php');
            } else {
                if (@file_exists('modules/' . $this->name . '/key.php')) {
                    @require_once('modules/' . $this->name . '/key.php');
                }
            }
        }
        if ($form == 1) {
            return '
            <div class="panel" id="fieldset_myprestaupdates" style="margin-top:20px;">
            ' . ($this->psversion() == 6 || $this->psversion() == 7 ? '<div class="panel-heading"><i class="icon-wrench"></i> ' . $this->l('MyPresta updates') . '</div>' : '') . '
			<div class="form-wrapper" style="padding:0px!important;">
            <div id="module_block_settings">
                    <fieldset id="fieldset_module_block_settings">
                         ' . ($this->psversion() == 5 ? '<legend style="">' . $this->l('MyPresta updates') . '</legend>' : '') . '
                        <form action="' . $_SERVER['REQUEST_URI'] . '" method="post">
                            <label>' . $this->l('Check updates') . '</label>
                            <div class="margin-form">' . (Tools::isSubmit('submit_settings_updates_now') ? ($this->inconsistency(0) ? '' : '') . $this->checkforupdates(1) : '') . '
                                <button style="margin: 0px; top: -3px; position: relative;" type="submit" name="submit_settings_updates_now" class="button btn btn-default" />
                                <i class="process-icon-update"></i>
                                ' . $this->l('Check now') . '
                                </button>
                            </div>
                            <label>' . $this->l('Updates notifications') . '</label>
                            <div class="margin-form">
                                <select name="mypresta_updates">
                                    <option value="-">' . $this->l('-- select --') . '</option>
                                    <option value="1" ' . ((int)(Configuration::get('mypresta_updates') == 1) ? 'selected="selected"' : '') . '>' . $this->l('Enable') . '</option>
                                    <option value="0" ' . ((int)(Configuration::get('mypresta_updates') == 0) ? 'selected="selected"' : '') . '>' . $this->l('Disable') . '</option>
                                </select>
                                <p class="clear">' . $this->l('Turn this option on if you want to check MyPresta.eu for module updates automatically. This option will display notification about new versions of this addon.') . '</p>
                            </div>
                            <label>' . $this->l('Module page') . '</label>
                            <div class="margin-form">
                                <a style="font-size:14px;" href="' . $this->mypresta_link . '" target="_blank">' . $this->displayName . '</a>
                                <p class="clear">' . $this->l('This is direct link to official addon page, where you can read about changes in the module (changelog)') . '</p>
                            </div>
                            <div class="panel-footer">
                                <button type="submit" name="submit_settings_updates"class="button btn btn-default pull-right" />
                                <i class="process-icon-save"></i>
                                ' . $this->l('Save') . '
                                </button>
                            </div>
                        </form>
                    </fieldset>
                    <style>
                    #fieldset_myprestaupdates {
                        display:block;clear:both;
                        float:inherit!important;
                    }
                    </style>
                </div>
            </div>
            </div>';
        } else {
            if (defined('_PS_ADMIN_DIR_')) {
                if (Tools::isSubmit('submit_settings_updates')) {
                    Configuration::updateValue('mypresta_updates', Tools::getValue('mypresta_updates'));
                }
                if (Configuration::get('mypresta_updates') != 0 || (bool)Configuration::get('mypresta_updates') != false) {
                    if (Configuration::get('update_' . $this->name) < (date("U") - 259200)) {
                        $actual_version = relatedfreeUpdate::verify($this->name, (isset($this->mkey) ? $this->mkey : 'nokey'), $this->version);
                    }
                    if (relatedfreeUpdate::version($this->version) < relatedfreeUpdate::version(Configuration::get('updatev_' . $this->name))) {
                        $this->context->controller->warnings[] = '<strong>' . $this->displayName . '</strong>: ' . $this->l('New version available, check http://MyPresta.eu for more informations') . ' <a href="' . $this->mypresta_link . '">' . $this->l('More details in changelog') . '</a>';
                        $this->warning                         = $this->context->controller->warnings[0];
                    }
                }
                if ($display_msg == 1) {
                    if (relatedfreeUpdate::version($this->version) < relatedfreeUpdate::version(relatedfreeUpdate::verify($this->name, (isset($this->mkey) ? $this->mkey : 'nokey'), $this->version))) {
                        return "<span style='color:red; font-weight:bold; font-size:16px; margin-right:10px;'>" . $this->l('New version available!') . "</span>";
                    } else {
                        return "<span style='color:green; font-weight:bold; font-size:16px; margin-right:10px;'>" . $this->l('Module is up to date!') . "</span>";
                    }
                }
            }
        }
    }

    public function getContent()
    {
        if (Tools::isSubmit('btnSubmit')){
            Configuration::updateValue('rf_tpath', Tools::getValue('rf_tpath', 'product-list.tpl'));
            Configuration::updateValue('rf_maincss', Tools::getValue('rf_maincss', 'block products_block clearfix'));
            Configuration::updateValue('rf_productscss', Tools::getValue('rf_productscss', 'related_products tab-pane'));
            $this->context->controller->confirmations[] = $this->l('Settings saved');
        }
        return $this->renderForm().$this->checkforupdates(0, 1);
    }

    public function renderForm()
    {
        $fields_form = array(
            'form' => array(
                'legend'      => array(
                    'title' => $this->l('Settings of the module'),
                    'icon'  => 'icon-cubes',
                ),
                'description' => $this->l('With this form you will configure global settings of the module. If you are looking for form to define "related products" - you can find it on each product edit page (there is a section with modules where you can manage this module settings)'),
                'input'       => array(
                    array(
                        'type'  => 'text',
                        'label' => $this->l('Path to .tpl file of product miniature'),
                        'name'  => 'rf_tpath',
                        'desc'  => $this->l('default value for Prestashop 1.6 default-bootstrap theme: product-list.tpl') . '<br/>' . $this->l('If you want to use non-default path - make sure that this file exists, otherwise website will spawn error about "unable to load template file"') . '<div class="alert alert-info">' . $this->l('Module to build list of products will use theme file that is responsible for "miniature" of product on list of products. If your theme does not follow prestashop standards and uses own not-default .tpl files - you can type here the path to this .tpl file. This option makes the module compatible with all themes.') . '</div>',
                    ),
                    array(
                        'type'  => 'text',
                        'label' => $this->l('CSS class of main div with products'),
                        'name'  => 'rf_maincss',
                        'desc'  => $this->l('default value for Prestashop 1.6 default-bootstrap theme: "block products_block clearfix"'),
                    ),
                    array(
                        'type'  => 'text',
                        'label' => $this->l('CSS class of block with products'),
                        'name'  => 'rf_productscss',
                        'desc'  => $this->l('default value for Prestashop 1.6 default-bootstrap theme: "related_products tab-pane"'),
                    ),
                ),
                'submit'      => array(
                    'title' => $this->l('Save'),
                )
            ),
        );

        $helper                           = new HelperForm();
        $helper->default_form_language    = $this->context->language->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
        $helper->identifier               = 'rf_settings';
        $helper->submit_action            = 'btnSubmit';
        $helper->currentIndex             = $this->context->link->getAdminLink('AdminModules', false) . '&configure=' . $this->name . '&tab_module=' . $this->tab . '&module_name=' . $this->name;
        $helper->token                    = Tools::getAdminTokenLite('AdminModules');
        $helper->tpl_vars                 = array(
            'fields_value' => $this->getConfigFieldsValues(),
            'languages'    => $this->context->controller->getLanguages(),
            'id_language'  => $this->context->language->id
        );

        return $helper->generateForm(array($fields_form));
    }

    public function getConfigFieldsValues()
    {
        return array(
            'rf_tpath' => Tools::getValue('rf_tpath', $this->return_rf_tpath()),
            'rf_maincss' => Tools::getValue('rf_maincss', Configuration::get('rf_maincss')),
            'rf_productscss' => Tools::getValue('rf_productscss', Configuration::get('rf_productscss')),
        );
    }

    public function install()
    {
        if ($this->psversion() == 5 || $this->psversion() == 6)
        {
            if (parent::install() == false or
                !Configuration::updateValue('rf_tpath', 'product-list.tpl') or
                !Configuration::updateValue('rf_maincss', 'block products_block clearfix') or
                !Configuration::updateValue('rf_productscss', 'related_products tab-pane') or
                !$this->registerHook('displayHeader') or
                !$this->registerHook('productFooter') or
                !$this->registerHook('displayAdminProductsExtra') or
                !$this->registerHook('actionProductUpdate'))
            {
                return false;
            }
        }
        return true;
    }

    public function hookActionProductUpdate($params)
    {
        if (Tools::isSubmit('relatedfree'))
        {
            Configuration::updateValue('related_category' . Tools::getValue('id_product'), Tools::getValue('related_category'));
            Configuration::updateValue('related_nb' . Tools::getValue('id_product'), Tools::getValue('related_nb'));
            Configuration::updateValue('related_link' . Tools::getValue('id_product'), Tools::getValue('related_link'));
        }
    }

    public function hookDisplayAdminProductsExtra($params)
    {
        $this->context->smarty->assign('related_category', Configuration::get('related_category' . Tools::getValue('id_product')));
        $this->context->smarty->assign('related_nb', Configuration::get('related_nb' . Tools::getValue('id_product')));
        $this->context->smarty->assign('related_link', Configuration::get('related_link' . Tools::getValue('id_product')));
        return $this->display(__FILE__, 'views/templates/admin/tabs.tpl');
    }

    public function hookProductFooter($params)
    {
        $category = new Category(Configuration::get('related_category' . Tools::getValue('id_product')));
        $blocks_products = $category->getProducts($this->context->cookie->id_lang, 0, Configuration::get('related_nb' . Tools::getValue('id_product')));
        $this->context->smarty->assign('blocks_products', $blocks_products);
        $this->context->smarty->assign('id_lang', $this->context->language->id);
        $this->context->smarty->assign('related_category', Configuration::get('related_category' . Tools::getValue('id_product')));
        $this->context->smarty->assign('related_link', Configuration::get('related_link' . Tools::getValue('id_product')));
        $this->context->smarty->assign('rf_tpath', $this->return_rf_tpath());
        $this->context->smarty->assign('rf_maincss', Configuration::get('rf_maincss'));
        $this->context->smarty->assign('rf_productscss', Configuration::get('rf_productscss'));

        return $this->display(__file__, 'products16.tpl');
    }

    public function hookHeader($params)
    {
        if (isset($this->context->controller->php_self) && $this->context->controller->php_self == 'product')
        {
            $this->context->controller->addCSS(_THEME_CSS_DIR_ . 'product_list.css');
        }
    }

    public function msg_saved()
    {
        return '<div class="conf confirm">' . $this->l('Saved') . '</div>';
    }

    public function displayForm()
    {
        $output = '';
        $form = '';
        $form .= '
                <fieldset>
                    <legend><img src="' . $this->_path . 'logo.gif" alt="" title="" />' . $this->l('Global Settings') . '</legend>
                    <form name="globalsettings" id="globalsettings" method="post">
                        <div class="bootstrap">
	                        <div class="alert alert-info">
								' . $this->l('Select the way of how tabs on product page will appear. If you are on prestashop 1.6 with default-bootstrap theme and want to use real product tabs like it was in 1.5 please follow this guide: ') . ' <a href="http://mypresta.eu/en/art/prestashop-16/product-tabs.html" target="_blank"/>' . $this->l('real product tabs in prestashop 1.6') . '</a>
							</div>
						</div>
                        <label>' . $this->l('Select tabs type') . '</label>
            			<div class="margin-form">
                            <select type="text" name="ppb_internal_tabs" style="max-width:200px;">
                                <option value="1" ' . (Configuration::get('ppb_internal_tabs') == 1 ? "selected=\"selected\" " : "") . '>' . $this->l('PrestaShop 1.6 type (wide bars)') . '</option>
                                <option value="0" ' . (Configuration::get('ppb_internal_tabs') == 1 ? "" : "selected=\"selected\" ") . '>' . $this->l('PrestaShop 1.5 type (real tabs)') . '</option>
                            </select>
           				</div>
                        <input type="submit" class="extra button" name="global_settings" value="' . $this->l('save settings') . ' "/>
                     </form>
                 </fieldset>';

        return $output . '
        <script type="text/javascript" src="../modules/ppb/js/script.js"/></script>
        <script type="text/javascript">
    			$(function() {
    				var $mySlides = $("#homepageblocks");
    				$mySlides.sortable({
    					opacity: 0.6,
    					cursor: "move",
    					update: function() {
    						var order = $(this).sortable("serialize") + "&action=updateSlidesPosition";
    						$.post("' . _PS_BASE_URL_ . __PS_BASE_URI__ . 'modules/' . $this->name . '/ajax_' . $this->name . '.php", order);
    						}
    					});
    				$mySlides.hover(function() {
    					$(this).css("cursor","move");
    					},
    					function() {
    					$(this).css("cursor","auto");
    				});
    			});
    		    </script>
        <style>
            .language_flags {text-align:left;}
            #topmenu-horizontal-module {overflow:hidden; background-color: #F8F8F8; border: 1px solid #CCCCCC; margin-bottom: 10px; padding: 10px 0; border-radius: 3px; -moz-border-radius: 3px; -webkit-border-radius: 3px;}
            #topmenu-horizontal-module .addnew, #topmenu-horizontal-module .btnpro {-webkit-border-radius:4px; -moz-border-radius:4px; -border-radius:4px; padding:5px; margin-right:10px; cursor:pointer; width:52px; height:52px; display:inline-block; float:right; text-align:center; border:1px dotted #c0c0c0; }
            #topmenu-horizontal-module .addnew:hover, #topmenu-horizontal-module .btnpro:hover {border:1px solid #bfbfbf; background:#f3f3f3;}
            #topmenu-horizontal-module span.img {margin:auto; width:32px; height:32px; display:block;}
            #topmenu-horizontal-module span.txt {margin-top:3px; width:52px; display:block; text-align:center;}
            #topmenu-horizontal-module .addnew span.img {background:url(\'' . _MODULE_DIR_ . $this->name . '/img/add.png\') no-repeat center;}
            #topmenu-horizontal-module .save span.img {background:url(\'' . _MODULE_DIR_ . $this->name . '/img/on.png\') no-repeat center;}
            #topmenu-horizontal-module .back span.img {background:url(\'' . _MODULE_DIR_ . $this->name . '/img/back.png\') no-repeat center;}

                .slides {margin:0px; padding:0px;}
                .slides li { font-size:15px!important; list-style: none; margin: 0 0 4px 0; padding: 15px 10px; background-color: #F4E6C9; border: #CCCCCC solid 1px; color:#000;}
                .slides li:hover {border:1px #000 dashed; cursor:move;}
                .slides li .name {font-size:18px!important;}
                .slides li .nb {color:#FFF; background:#000; padding:5px 10px; font-size:18px; font-weight:bold; margin-right:10px; }

                .activate {display:inline-block; float:right; padding-right:5px;  cursor:pointer; position:relative; top:2px;}
                .activate img {max-width:50px; height:auto;}
                .remove {opacity:0.3; position:relative; top:-1px; width:24px; height:24px; display:inline-block; float:right; background:url("../modules/' . $this->name . '/img/trash.png") top no-repeat; cursor:pointer;}
                .edit {margin-right:6px; opacity:0.3; position:relative;  width:24px; height:24px; display:inline-block; float:right; background:url("../modules/' . $this->name . '/img/edit.png") top no-repeat; cursor:pointer;}

                .remove:hover, .edit:hover, .activate:hover { opacity:1.0; }
                .edit,.remove {margin-right:5px;}


        </style>
        <form name="selectform1" id="selectform1" action="' . $_SERVER['REQUEST_URI'] . '" method="post"><input type="hidden" name="selecttab" value="1"></form>
        <form name="selectform2" id="selectform2" action="' . $_SERVER['REQUEST_URI'] . '" method="post"><input type="hidden" name="selecttab" value="2"></form>
        <form name="selectform3" id="selectform3" action="' . $_SERVER['REQUEST_URI'] . '" method="post"><input type="hidden" name="selecttab" value="3"></form>
        <form name="selectform4" id="selectform4" action="' . $_SERVER['REQUEST_URI'] . '" method="post"><input type="hidden" name="selecttab" value="4"></form>
        <form name="selectform99" id="selectform99" action="' . $_SERVER['REQUEST_URI'] . '" method="post"><input type="hidden" name="selecttab" value="99"></form>
        ' . "<div id='cssmenu'>
            <ul>
               <li class='bgver'><a><span>v" . $this->version . "</span></a></li>
               <li style='position:relative; display:inline-block; float:right; '><a style=\"display:block; width:40px;\" href='http://mypresta.eu' target='_blank' title='prestashop modules'><span ><img src='../modules/ppb/img/logo-white.png' alt='prestashop modules' style=\"position:absolute; top:17px; right:16px;\"/></span></a></li>
            </ul>
        </div>" . '<link href="../modules/' . $this->name . '/css.css" rel="stylesheet" type="text/css" />' . $form;
    }
}

class relatedfreeUpdate extends relatedfree
{
    public static function version($version)
    {
        $version = (int)str_replace(".", "", $version);
        if (strlen($version) == 3)
        {
            $version = (int)$version . "0";
        }
        if (strlen($version) == 2)
        {
            $version = (int)$version . "00";
        }
        if (strlen($version) == 1)
        {
            $version = (int)$version . "000";
        }
        if (strlen($version) == 0)
        {
            $version = (int)$version . "0000";
        }
        return (int)$version;
    }

    public static function encrypt($string)
    {
        return base64_encode($string);
    }

    public static function verify($module, $key, $version)
    {
        if (ini_get("allow_url_fopen"))
        {
            if (function_exists("file_get_contents"))
            {
                $actual_version = @file_get_contents('http://dev.mypresta.eu/update/get.php?module=' . $module . "&version=" . self::encrypt($version) . "&lic=$key&u=" . self::encrypt(_PS_BASE_URL_ . __PS_BASE_URI__));
            }
        }
        Configuration::updateValue("update_" . $module, date("U"));
        Configuration::updateValue("updatev_" . $module, $actual_version);
        return $actual_version;
    }
}
?>